'' =================================================================================================
''
''   File....... jm_bicolor_test.spin
''   Purpose.... Test program for multi-phase, bi-color LED object
''   Author..... Jon "JonnyMac" McPhalen (aka Jon Williams)
''   E-mail..... jon@jonmcphalen.com
''   Started.... 
''   Updated.... 10 MAY 2010 
''
'' =================================================================================================


CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  

CON

  #1, HOME, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR, #16, CLS      ' PST formmatting control

  
CON

  #0, OFF, RED, GRN, YEL                                        ' led colors

  R_LED = 17                                                    ' on Propeller Platform
  G_LED = 16

  
OBJ

  term : "fullduplexserial"             
  led  : "jm_bicolor_v4"


VAR
  

PUB main | c

  term.start(31, 30, %0000, 115_200)                            ' terminal on programming port
  led.init(R_LED, G_LED)                                        ' bi-color LED

  pause(1)
  term.str(@Menu)

  repeat
    c := term.rx
    case c
      "0" : led.off
      "1" : led.red
      "2" : led.green
      "3" : led.yellow
      "4" : led.set2phase(RED, 250, OFF, 250)
      "5" : led.set2phase(GRN, 500, YEL, 500)
      "6" : led.set3phase(RED, 333, YEL, 333, GRN, 333)
      "7" : led.set4phase(RED, 125, OFF, 375, YEL, 125, OFF, 375)
     

PUB pause(ms) | t

  t := cnt                                                      ' sync with system counter
  repeat ms
    waitcnt(t += MS_001)
    

DAT

Menu                    byte    CLS
                        byte    "Multi-phase, bi-color LED Test", CR
                        byte    CR
                        byte    "[0] Off", CR
                        byte    "[1] Solid red", CR
                        byte    "[2] Solid green", CR
                        byte    "[3] Solid yellow", CR
                        byte    "[4] R:250, X:250", CR
                        byte    "[5] G:500, Y:500", CR
                        byte    "[6] R:333, Y:333, G:333", CR
                        byte    "[7] R:125, X:375, Y:125, X:375", CR
                        byte    CLRDN
                        byte    0 
                        
                        